// The Guillotine!
// by ptdw
//
// v4.2
//
// COPYRIGHT:
// This script, from http://ss.deviatenow.com, is protected by this licence:
// CC BY-SA 4.0, see http://creativecommons.org/licenses/by-sa/4.0/
// This copyright refers only to this script itself; it does not include any other included resources
// (images, music, sounds, etc.) which remain the property of their owners.
//
// Change Log
// 1.1 Added female victim
// 1.2 Added random malfunction option
// 1.3 Fixed repair times
// 2.0 Added the option of publishing a live stream
// 2.1 Minor enhancements, breaking news
// 3.0 Scheduled castration, better url handling
// 3.1 Fixed minor bug to clear publication after finished
// 4.0 Added audio for no audio-baswed e-stim
// 4.1 Minor fix for e-stim path, minor sound changes
// 4.2 Fixed audio on fall

setInfos(9, "The Guillotine", "A virtual guillotine for e-stim play.","ptdw", "v4.2", 0x222222, "en", ["pain", "cbt", "estim", "formale", "forfemale", "internet", "android"]);

// Debug-sensitive variables
def identifier = loadInteger("intro.launch.firsttime")
def playerName = loadString("intro.name")
def properName = playerName.substring(0, 1).toUpperCase() + playerName.substring(1)
def femalePlayer = loadBoolean("intro.female")
def reset = false
def livePlayer = null
def schPlayer = null 
def long schTime = 0
def breakingNews = null
def long liveTime = 0
def liveURL = null
def newsURL = null
def currentTime = 0
def severe = false
def path = System.getProperty("user.dir")

// Set default non-volative variables
if(loadBoolean("stripordie.audio_estim")==null || reset)
    save("stripordie.audio_estim",true)
if(loadString("stripordie.estim_start")==null || reset)
    save("stripordie.estim_start","usbcontrol.exe start")
if(loadString("stripordie.estim_finish")==null || reset)
    save("stripordie.estim_finish","usbcontrol.exe stop")
if(loadInteger("guillotine.min_time")==null || reset)
    save("guillotine.min_time",30)
if(loadInteger("guillotine.max_time")==null || reset)
    save("guillotine.max_time",60)
if(loadInteger("guillotine.malf_chance")==null || reset)
    save("guillotine.malf_chance",1)
if(loadInteger("guillotine.bind_time")==null || reset)
    save("guillotine.bind_time",60)
if(loadInteger("guillotine.retry")==null || reset)
    save("guillotine.retry",0)
if(loadBoolean("guillotine.surprise")==null || reset)
    save("guillotine.surprise",false)
if(loadBoolean("guillotine.broadcast")==null || reset)
    save("guillotine.broadcast",false)
if(loadString("guillotine.link")==null || reset)
    save("guillotine.link","")
if(loadString("guillotine.schedule")==null || reset)
    save("guillotine.schedule",0)
if(loadBoolean("guillotine.nohands")==null || reset)
    save("guillotine.nohands",false)
if(loadInteger("guillotine.nohands_delay")==null || reset)
    save("guillotine.nohands_delay",60)

// Read non-volatile variables
def audio_estim = loadBoolean("stripordie.audio_estim")
def estim_start = loadString("stripordie.estim_start")
def estim_finish = loadString("stripordie.estim_finish")
def minTime = loadInteger("guillotine.min_time")
def maxTime = loadInteger("guillotine.max_time")
def malfChance = loadInteger("guillotine.malf_chance")
def bindTime = loadInteger("guillotine.bind_time")
def retry = loadInteger("guillotine.retry")
def surprise = loadBoolean("guillotine.surprise")
def broadcast = loadBoolean("guillotine.broadcast")
def link = loadString("guillotine.link")
def schedule = loadInteger("guillotine.schedule")
def noHands = loadBoolean("guillotine.nohands")
def noHandsDelay = loadInteger("guillotine.nohands_delay")

// Regular variables
def delayTime = 0
def intTime = 0

//Rules explaination
def rulesDisplay = {
    show("This script is a virtual guillotine, and is fully configurable. "
	+"\n\nYou will connect a computer-controlled torture device (such as e-stim) to your genitals. Then, you'll bind yourself so that you cannot escape quickly. "
	+"\n\nYou may even want to use an external self-bondage app to ensure you remain bound for a certain duration."
	+"\n\nAfter your genitals are connected and you are bound, the blade will slowly start to rise, in accordance with the min and max times you have set.")
    showButton("What happens when the blade reaches the top?")
    show("Glad you asked! After the blade is fully raised, it will come slamming back down, with your helpless genitals directly in its path!"
	+"\n\nHowever, there is a chance that the guillotine will malfunction. If it malfunctions, the guards may repair it, but that's up to you.")
    showButton("And if it doesn't malfunction?")
    show("Once the blade reaches your genitals, the torture device will trigger!"
	+"\n\nSince you can set your own odds, it's best to play with your torture device set to a level of pain higher than normal. That will ensure you "
    +"are properly dreading the moment the blade falls! ")
    showButton("Is there any other way to escape the blade?")
    show("In theory, you could bind yourself in a manner that allows you to escape, but requires sufficient time.\n\nThen, set the guillotine to trigger "
	+"in a similar amount of time, forcing you to race the clock.")
    showButton("Okay...")
    show("Regardless of how you choose to play, your genitals will be in great peril of extreme pain.\n\nLet's hope lady luck is watching over you... ")
    showButton("*gulp*")
}

def Rules = {
    rulesDisplay()
    while(getBoolean("Do you need to go back over the rules again?","Yes","I understand them"))
    {
        rulesDisplay()
    }
}

// Show a countdown
def Countdown = { count, msg ->

	for(def k = count;k > 0;k--) {
		show(msg+"\n\n... "+k+" ...")
		wait(1)
	}
}


def Schedule = {
    def text = "Have you been sentenced to the guillotine and want to make sure your punishment is enforced? Schedule your castration in advance!"
	text += "\n\nIf you have broadcast enabled in settings, we'll advertise your planned castration so that other players can watch live! "
	text += "\n\nRegardless of wether or not you broadcast, you must submit to the guillotine within one hour after your scheduled castration. "
	text += "\n\nIf you don't show up on time, you will anger the guards and will be severely punished the next time you run the script. "
   
	def hours = getInteger(text + "\n\nHow many hours until your castration? (or 0 to cancel):", 0)
	if (hours > 0) {
		schedule = getTime() + (60 * 60 * hours)
 	   	save("guillotine.schedule",schedule)	
		text = "You are scheduled to be castrated on the guillotine in "+hours+" hour"
		if (hours > 1) text += "s"
		text += " from now.\n\nFor your own sake, make sure to show up on time!"
		show(text)
		showButton("*gulp*")

		// Only advertise if sooner than other player
		if (broadcast && ((schPlayer == "") || (schTime > schedule))) {
			send("guillotine.sch_name",properName)
			send("guillotine.sch_time",schedule.toString())
		}
	}
}

// Display when a bad URL is given
def badURL = {
	show("That's not a valid URL!\n\nMaybe you forgot the \"http://\"?\n\nLet's try that again...")
	wait(3)
}

// Check for live players
def getLive = {
	livePlayer = receiveString("guillotine.name")
	breakingNews = receiveString("guillotine.news")
	schPlayer = receiveString("guillotine.sch_name")

	// Handle breaking news
	if ((breakingNews != null)  && (breakingNews != "")) newsURL = receiveString("guillotine.news_url")

	// Validate live player
	currentTime = new Date()
	if (livePlayer == null) livePlayer = ""
	if (livePlayer != "") {
		def temp = receiveString("guillotine.time")
		if (temp == null) liveTime = 0
		else liveTime = Long.parseLong(temp)
		liveURL = receiveString("guillotine.url")

		// Delete invalid players
		currentTime = new Date()
		if (((currentTime.time/1000) - liveTime > 3600) || (liveTime == 0) || (liveURL == null) || (liveURL == "")) {
			livePlayer = ""
			send("guillotine.name",livePlayer)
		}
	}

	// Validate scheduled player
	if (schPlayer == null) schPlayer = ""
	if (schPlayer != "") {
		def temp = receiveString("guillotine.sch_time")
		if (temp == null) schTime = 0
		else schTime = Long.parseLong(temp)

		// Delete invalid players
		if (getTime() > schTime+3600) {
			send("guillotine.sch_name",null)
			schPlayer = ""
			schTime = 0
		} 
	}
}

def Setup = {
    def stimOk = false
	def valid = false

	// Broadcast?
    setImage("guillotine/paparazzi.jpg")
	if (getBoolean("If you have a webcam, you can publish a link to your live stream when you are on the guillotine. "
		+"\n\nOther players who open the script while you're on the guillotine will be given the URL and can watch your castration."
		+"\n\nDo you want to publish a live stream URL when you are on the guillotine?","Yes","No")) {

		show("You will be prompted to enter the URL for your live stream at the time of your castration."
		+"\n\nPopular sites include: appear.in, tinychat, chaturbate, and cam4. "
		+"\n\nPlease have a site in mind and ready to go at the time of your punishment!")
		showButton("OK")
		broadcast = true
	} else {
		broadcast = false
	}

	// Basic setup of time and probability of failure
    setImage("guillotine/stopwatch.png")
	valid = false
	while (!valid) {
		minTime = getInteger("Set the minimum time before the blade falls (in seconds) [10+]:", minTime)
		if (minTime >= 10) valid = true 
	}
	valid = false
	while (!valid) {
		maxTime = getInteger("Set the maximum time before the blade falls (in seconds) [>"+minTime+"]:", maxTime)
		if (maxTime >= minTime) valid = true
	}
	valid = false
	while (!valid) {
		bindTime = getInteger("How much time do you need to bind yourself before starting the guillotine sequence (in seconds):", bindTime)
		if (bindTime >= 0) valid = true
	}
	noHands = false
	if (getBoolean("Would you like to use hands-free mode, which doesn't require any mouse input once you start?",
		"Yes","No")) {
		noHands = true
		valid = false
		while (!valid) {
			noHandsDelay = getInteger("How long do you need in between commands (e.g., take off your clothes)? [>10]:", noHandsDelay)
			if (noHandsDelay >= 10) valid = true 
		}
	}
    setImage("guillotine/gears.png")
	if (getBoolean("Would you like to set the odds of malfunction?  Or should I surprise you once you're tied up and it's too late to back out?",
	"I'll set the odds","Surprise me")) {
		valid = false
		while (!valid) {
			malfChance = getInteger("Set the chance that the guillotine will malfunction [0-10]:", malfChance)
			if ((malfChance >= 0) && (malfChance <= 10)) valid = true
		}
		surprise = false
	} else {
		surprise = true
	}
	valid = false
	while (!valid) {
		retry = getInteger("If the guillotine malfunctions, how many times should the guards try to fix it?:", retry)
		if (retry >= 0) valid = true
	}

    save("guillotine.min_time",minTime)
    save("guillotine.max_time",maxTime)
    save("guillotine.bind_time",bindTime)
    save("guillotine.malf_chance",malfChance)
    save("guillotine.retry",retry)
    save("guillotine.surprise",surprise)
    save("guillotine.broadcast",broadcast)
    save("guillotine.nohands",noHands)
    save("guillotine.nohands_delay",noHandsDelay)

    // Customize punishment
    setImage("guillotine/pain.png")
    def menu = getSelectedValue("For the most realistic experience, I need a method of automatically inflicting "
    +"your genitals with severe pain when the blade falls."
    +"\n\nBy default, the game uses an audio-based e-stim device, which is connected to your computer's headphone port. "
    +"\n\nHowever, you can also choose to use any sort of external device, which is controlled by a start and stop command "
    +"run by your computer when the blade falls."
    +"\n\nHow will pain be inflicted?", ["External Device","Audio E-stim"])

    // Audio e-stim
    setImage("stripordie/abox.png")
    if(menu==1) {
        audio_estim = true
        while (!stimOk) {
            if (getBoolean("If you want to get a small taste of what it will feel like when the blade falls, press the \"TEST\" button "
                +"to feel a short sample at half the intensity."
                +"\n\nIf you think this is painful, just wait until the blade cuts for real!","TEST","Continue")) {

                playBackgroundSound("guillotine/guilcal.wav")
                wait(1)

            } else stimOk = true
        }
    }

    // External device
    else if(menu==0) {
        audio_estim = false

        // Test and setup the external device
        def extOk = false
        while (!extOk) {

            // Define the external commands used to control the device
            setImage("stripordie/2b.png")
            estim_start = getString("Let's make sure your computer is linked to your device with the correct commands."
            +"\n\nWhat is the command your computer runs to start your device:",estim_start)
            estim_finish = getString("What is the command your computer runs to stop your device:",estim_finish)

            // Test
            stimOk = false
            while (!stimOk) {
                if (getBoolean("It is best to have a quick test first! Turn the output down to half and press the \"TEST\" button "
                    +"to feel a short sample - remember to put the output back up to full after."
                    +"\n\nIf you think this is painful, just wait until the blade falls!","TEST","Continue")) {

                    useFile(path+"/"+estim_start)
                    wait(2)
                    useFile(path+"/"+estim_finish)
                    wait(1)

                    if (getBoolean("Did the device work correctly?","Yes","No")) {
                        stimOk = true
                        extOk = true
                    } else stimOk = true
                } else {
                    stimOk = true
                    extOk = true
                }
            }
        }
    }

    save("stripordie.audio_estim",audio_estim)
    save("stripordie.estim_start",estim_start)
    save("stripordie.estim_finish",estim_finish)
}

// Tease the player as the guillotine is lifting
def taunt = {
	def tauntText = ["Your poor cock is so helpless!",
    "The higher the blade raises, the closer it is to slamming down!",
    "You must be sweating bullets now...",
    "If you're religious, you should start praying!",
    "The pain will be intense, but thankfully the blade is swift!",
    "Look at that sharp heavy blade hovering over your helpless cock!",
    "Do you think you can escape? Maybe it will malfunction...",
    "Only time is separating the edge of the blade from your cock!"]

	if (femalePlayer) {
		tauntText = ["Your poor body is so helpless!",
    		"The higher the blade raises, the closer it is to slamming down!",
    		"You must be sweating bullets now...",
    		"If you're religious, you should start praying!",
    		"The pain will be intense, but thankfully the blade is swift!",
    		"Look at that sharp heavy blade hovering over your helpless pussy!",
    		"Do you think you can escape? Maybe it will malfunction...",
    		"Only time is separating the edge of the blade from your pussy!"]
	}
	show(tauntText[getRandom(8)])
}

if (femalePlayer)
	setImage("guillotine/guillotine1f.png")
else
	setImage("guillotine/guillotine1.png")

// Intro
def initial_setup = true
def quit = false
def menu = ""
while(initial_setup)
{
    setImage("guillotine/guillotine.jpg")
	getLive()
	def text = "<h1>The Guillotine</h1>Hi, "+playerName+"! Welcome to \"The Guillotine\"!"

	// Scheduled castration?
	if (schedule > 0) {
		def timeLeft = schedule - getTime()
		if (timeLeft > 0) {
			while (timeLeft > 0) {
    				def text1 = "\n\n<font color=red><b>You are scheduled for castration in "
				text1 += (int) (timeLeft/3600)+":"+(int) ((timeLeft%3600)/60) + ":" + (int)timeLeft%60+"</b></font>"
				text1 += "\n\nCome back within one hour after your scheduled time, or face the wrath of the guards!"
				timeLeft = schedule - getTime()
				show(text+text1)
				wait(1)
			}
		}
		if (timeLeft + 3600 >= 0) {
			show("<h2>It's Time!</h2>You have returned on schedule, and will now be locked in the guillotine for castration."
			+"\n\nThis is not optional! Failure to complete your punishment on time will result in severe punishment by the guards!")
			showButton("I'm ready now")
			menu = 3
		} else {			
			severe = true;
			if (malfChance > 3) malfChance = getRandom(3)+1
			text = "<h2>You're Late!</h2>"
			text += "The guards are furious, and vow to not give up until you are successfully castrated.  "
			text +="\n\nAdditionally, they want to ensure the castration is as painful as possible. "
			if (femalePlayer) {
				text += "They demand that you use an electrode that penetrates your vagina!\n\nNo external electrodes this time!"
			} else {
				text += "They demand that you use an electrode that penetrates the urethra!\n\nNo external electrodes this time!"
			}
			show(text)
			showButton("Sorry!")
			menu = 3
		}	 
	} else {	
		if (femalePlayer) {
    			text +="\n\nYou have been sentenced to virtual torture, and will submit your pussy to the cruel blade of the guillotine!"
		} else {
		    text +="\n\nYou have been sentenced to virtual castration, and will submit your cock to the cruel blade of the guillotine!"
		}

		// Check for live or news URL
		def openURL = null
		if ((liveURL != null) && (liveURL != "")) openURL = liveURL
		else if ((newsURL != null) && (newsURL != "")) openURL = newsURL

		// If another player is on the guillotine, advertise it
		if (livePlayer != "") {
			currentTime = new Date()
    			text +="\n\n<font color=yellow><b>WATCH LIVE:</b>  "+livePlayer+" is currently on the guillotine!</font>"
			if (openURL != null) menu = getSelectedValue(text, ["Instructions","Setup","Schedule","Play","Watch"])
		} else {
			if (schPlayer != "") {
				text +="\n\n<font color=yellow><b>WATCH LIVE:</b>  "
				currentTime = getTime()
				def hours = 0
				def minutes = 0
				if (schTime < currentTime) {
					text += schPlayer+" will be castrated within "
					minutes = (schTime+3600-currentTime)/60
    					text += (int) minutes+" minute"
					if (minutes != 1) text += "s"
					text += "!</font>"
				} else {
					text += schPlayer+" will be castrated in "
					hours = (schTime - currentTime)/3600
					minutes = ((schTime - currentTime)%3600)/60
					if (hours >= 1) {
						text += (int) hours + " hour"
						if (hours > 1) text += "s"
					}
					if (minutes > 0) {
						if (hours >= 1) text += " and "
						text += (int) minutes + " minute"
						if (minutes > 1) text += "s"
					}
					text += "!</font>"
				}
			}

			// Show the results of the last broadcast
			if ((breakingNews != null) && (breakingNews != ""))
    				text +="\n\n<font color=red><b>BREAKING NEWS:</b></font>  "+breakingNews
	
			// Change the button to remind the player if they are broadcasting
			def play = "Play"
			if (broadcast) play = "Broadcast"
			if (openURL != null) menu = getSelectedValue(text, ["Instructions","Setup","Schedule",play,"Watch"])
			else menu = getSelectedValue(text, ["Instructions","Setup","Schedule",play])
		}

   	 	// Open Link to live castration
		if(menu==4) {
			if (getBoolean("Please be cautious when opening unknown sites or files."
			+"\n\nDo you want to open " + openURL + " in an external browser?","Yes","No")) {
				useUrl(openURL)
			}
		}
	}

	// Other menu functions
    if(menu==1) Setup()
    else if(menu==0) Rules()
    else if(menu==2) Schedule()
    else if(menu==3) initial_setup = false
}

// Start the broadcast
if (broadcast) {
	setImage("guillotine/paparazzi.jpg")

	// Get the URL
	def valid = false
	while (!valid) {
		def prompt = "What is the URL you'll use for your live stream? Popular sites include: appear.in, tinychat, chaturbate, and cam4. "
		prompt += "\n\nBe sure to enter your personal broadcast URL, and not just the hosting site!"
		prompt += "\n\nEnter your live stream URL (HTTP):"
		link = getString(prompt, "")

		// https doesn't seem to work, convert to http
		link = link.replaceAll("https", "http")

		// Verify that the URL is valid
		try {
    			def URL url = new URL(link)
    			def URLConnection conn = url.openConnection()
    			conn.connect()
			valid = true
		} catch (MalformedURLException e) {
			badURL()
			valid = false
		} catch (IOException e) {
			bad(URL)
			valid = false
		}
	}
    save("guillotine.url",link)

	if ((livePlayer == "") || (livePlayer == playerName)) {
		show("The news crew has arrived and is ready to broadcast your castration."
		+"\n\nTIP: If possible, broadcast your screen with both your video and the guillotine app visible."
		+"\n\nStart your live stream now!")
		currentTime = new Date()
		liveTime = currentTime.time/1000
		send("guillotine.name",playerName)
		send("guillotine.url",link)
		send("guillotine.time",liveTime.toString())
		showButton("Broadcasting")
	} else {
		show("The news crew is currently busy filming another player.  This session will not be broadcast."
		+"\n\nIf you want to delay your castration, close the script and come back later.")

		showButton("Ok")
	}
}

def temp = ""
if (femalePlayer) {
	show("")
	setImage("guillotine/guillotine1f.png")
	if (!audio_estim) playBackgroundSound("guillotine/fear.mp3",10)
	temp = "It's time to begin your torture.\n\nStrip naked now!"
	show(temp)
	if (!audio_estim) playSound("guillotine/f_diag_01.mp3")
	if (noHands) Countdown(noHandsDelay,temp)
	else showButton("Naked")
	temp = "This is likely the last time you'll be able to get wet.\n\nMassage your pussy until it's wet and swollen--but no more!"
	show(temp)
	if (!audio_estim) playSound("guillotine/f_diag_02.mp3")
	setImage("guillotine/guillotine2f.png")
	if (noHands) Countdown(noHandsDelay,temp)
	else showButton("Wet")
	temp = "Prisoner! kneel in front of the guillotine with your swollen pussy exposed."
	temp += "\n\n(Attach the electrodes/torture device now)"
	show(temp)
	if (!audio_estim) playSound("guillotine/f_diag_03.mp3")
	if (noHands) Countdown(noHandsDelay,temp)
	else showButton("OK")
	setImage("guillotine/guillotine3f.png")
	temp = "Lay down on the guillotine platform!"
	temp +="\n\n(Power on your device and turn up the volume)"
	show(temp)
	if (!audio_estim) playSound("guillotine/f_diag_04.mp3")
	if (noHands) Countdown(noHandsDelay,temp)
	else showButton("OK")

} else {
	show("")
	setImage("guillotine/guillotine1.png")
	if (!audio_estim) playBackgroundSound("guillotine/fear.mp3",10)
	wait(3)
	temp = "It's time to begin your castration.\n\nStrip naked now!"
	show(temp)
	if (!audio_estim) playSound("guillotine/m_diag_01.mp3")
	if (noHands) Countdown(noHandsDelay,temp)
	else showButton("Naked")
	temp = "This is likely the last time you'll be able to get hard.\n\nMassage your cock until it's stiff enough to fit through the hole in the guillotine--but no more!"
	show(temp)
	if (!audio_estim) playSound("guillotine/m_diag_02.mp3")
	if (noHands) Countdown(noHandsDelay,temp)
	else showButton("Hard")
	setImage("guillotine/guillotine2.png")
	temp = "Prisoner! kneel in front of the guillotine with your swollen cock exposed."
	temp += "\n\n(Attach the electrodes/torture device now)"
	show(temp)
	if (!audio_estim) playSound("guillotine/m_diag_03.mp3")
	if (noHands) Countdown(noHandsDelay,temp)
	else showButton("OK")
	temp = "Insert your cock into the guillotine!"
	temp += "\n\n(Power on your device and/or turn up the volume)"
	show(temp)
	if (!audio_estim) playSound("guillotine/m_diag_04.mp3")
	setImage("guillotine/guillotine3.png")
	if (noHands) Countdown(noHandsDelay,temp)
	else showButton("OK")
}

show("This is your last chance to back out. Are you sure you are ready for this?")
if (!audio_estim) playSound("guillotine/m_diag_05.mp3")
if (noHands) wait(5)
else showButton("I'm Ready")
if (!audio_estim) playBackgroundSound(null)
show("Guards, bind the prisoner!"
+"\n\n(Attach restraints so that you cannot escape quickly)")
if (!audio_estim) {
	playSound("guillotine/m_diag_06.mp3")
	playBackgroundSound("guillotine/bind.mp3")
}
wait(4)
if (!audio_estim) playBackgroundSound("guillotine/breathing.mp3",100)

// Wait for the player to be bound
Countdown(bindTime,"Time remaining to securely bind yourself:")
wait(1)

// Reveal the surprise
if (surprise) {
	malfChance = getRandom(9) + 1
	show("Aww, you're so helpless like that! I bet you're hoping for a malfunction! Well...")
	if (!audio_estim) playSound("guillotine/m_diag_07.mp3")
	wait(10)
	if (malfChance < 5) {
		show("Sorry to tell you, but your chances aren't looking good!")
		if (!audio_estim) playSound("guillotine/m_diag_08.mp3")
	}
	else {
		show("You may get lucky this time...")
		if (!audio_estim) playSound("guillotine/m_diag_09.mp3")
	}
	wait(10)
	show("The chances of malfunction are "+malfChance+" in 10!")
	wait(10)
}

// Main loop
while (!quit) {
	def success = false
	def chop = false
	if (!audio_estim) playBackgroundSound(null)

	// Calculate the timing
	delayTime = getRandom(maxTime - minTime) + minTime

	show(null)
	intTime = (delayTime/10)

	// Raise the guillotine
	show("Guards, raise the blade!")
	if (!audio_estim) {
 		playSound("guillotine/m_diag_10.mp3")
		playBackgroundSound("guillotine/drums.mp3",100)
	}

	wait(3)

	def teaseTime = 0
	def x = 3
	def tease = 0
	(3..12).each {
		if (femalePlayer)
			setImage("guillotine/guillotine" + x + "f.png")
		else
			setImage("guillotine/guillotine" + x + ".png")

		// Randomly tease every 5 seconds or so
		if (x == 12) {
			show("Blade in position!")
			if (!audio_estim) {
				wait(1)
				playBackgroundSound("guillotine/latch.mp3")
				wait(1)
				playSound("guillotine/m_diag_11.mp3")
				wait(3)
				playBackgroundSound(null)
				playBackgroundSound("guillotine/heart.mp3",10)
			}
		} else {
			def currTime = getTime()
			if ((currTime - teaseTime>=10) && (tease == 0)) {
				taunt()
				teaseTime = currTime
			}
		}
		tease = getRandom(2)
		if (intTime > 2) wait(intTime-2)
		if ((!audio_estim) && (x!=12)) playBackgroundSound("guillotine/raise.mp3")
		wait(2)
		x++
	}

	// Hesitate
	wait(getRandom(5))
	if (!audio_estim) playBackgroundSound("guillotine/fall.mp3")
	wait(0.5)

	// Decide whether or not to chop
	if ((getRandom(10)+1) > malfChance) chop = true

	// Drop the guillotine
	x = 12
	show("Swhoosh!")

	// Trigger audio a bit early
	if (chop) {
		if (audio_estim) {
    			playBackgroundSound("guillotine/guilfall.wav")
		} else {
    			useFile(path+"/"+estim_start)
		}
	}

	// Show the falling blade
	(12..3).each {
		if (femalePlayer)
			setImage("guillotine/guillotine" + x + "f.png")
		else
			setImage("guillotine/guillotine" + x + ".png")

		wait(0.01)
		x--
	}

	// Chop
	if (!audio_estim) playBackgroundSound(null)
	def result = null
	if (chop) {
		if (femalePlayer) {
			show("***SWOOSH***")
			setImage("guillotine/guillotine13f.png")
		} else {
			if (!audio_estim) playBackgroundSound("guillotine/bounce.mp3")
			show("***WHACK***")
			setImage("guillotine/guillotine13.png")
		}

		wait(3)
        if (!audio_estim) {
        		useFile(path+"/"+estim_finish)
		}
		success = true
		if (femalePlayer) 
			show("Operation successful!")
		else 
			show("Castration successful!")
		if (!audio_estim) playBackgroundSound("guillotine/m_diag_12.mp3")
		wait(5)

		result = "That must have hurt!"

	// Malfunction
	} else {
		result = "You were spared!"
		if (!audio_estim) playBackgroundSound("guillotine/m_diag_13.mp3")
	}
	
	//Again?
	if (!success && ((retry >= 1) || severe)) {
		retry--
		show("Damn! It malfunctioned. Guards, repair the guillotine at once!")
		wait(5)
	} else if (!getBoolean(result+"\n\nWould you like to try again?", "Yes", "No")) {
		quit = true
	} else {
		retry = loadInteger("guillotine.retry")
	}
	if ((!quit) && (!audio_estim)) playBackgroundSound("guillotine/drums.mp3",100)

	// Stop the broadcast ad and publish the result
	if (broadcast) { 
    		setImage("guillotine/paparazzi.jpg")

		// Post castration interview
		def comment = getString("That must have been terrifying!"
			+"\n\nA reporter asks, \"How did you feel? Do you wish to make a statement?\" (optional)", "")
		send("guillotine.name","")
		def valid = false
		while (!valid) {
			newsURL = getString("Are there any photos or videos that we can publish? If so, enter the URL (optional):", "")
			if (newsURL == "") {
				newsURL = null
				valid = true
			} else {
				// https doesn't seem to work, convert to http
				newsURL = newsURL.replaceAll("https", "http")

				// Verify that the URL is valid
				try {
    					def URL url = new URL(newsURL)
    					def URLConnection conn = url.openConnection()
    					conn.connect()
					valid = true
				} catch (MalformedURLException e) {
					badURL()
					valid = false
				} catch (IOException e) {
					bad(URL)
					valid = false
				}
			}
		}

		def news = properName+" was the last prisoner broadcast live on the guillotine. "
		def genSpec = ["his","cock","he"]

		// Write the result
		news += "Too bad you missed it! "
		if (femalePlayer) {
			genSpec = ["her","pussy","she"]
		}
		if (success) news += "The guillotine worked flawlessly, and sliced through "+genSpec[0]+" helpless "+genSpec[1]+". Castration was successful! " 
		else news += "Unfortunately, the guillotine malfunctioned, and "+genSpec[2]+" was spared. "
		if (comment.length()>0) news += "\n\n<i>"+properName+" said: "+comment+"</i>"
		news += "\n\nCheck back often, and maybe you'll be lucky enough to watch the next victim!"

		send("guillotine.news",news)
		send("guillotine.news_url",newsURL)
		if (schPlayer == playerName) send("guillotine.sch_name",null)

		if (femalePlayer) setImage("guillotine/guillotine1f.png")
		else setImage("guillotine/guillotine1.png")
	}
}

// The end
save("guillotine.schedule",0)
show("Guards, release the prisoner!\n\nGoodbye...")
if (!audio_estim) playBackgroundSound("guillotine/m_diag_14.mp3")
showButton("Bye")

// This script, from http://ss.deviatenow.com, is protected by this licence :
// CC BY-SA 4.0, see http://creativecommons.org/licenses/by-sa/4.0/

/*
 * Resources
 * scripts/guillotine.groovy
 * images/guillotine/*
 * images/stripordie/abox.png
 * images/stripordie/2b.png
 * sounds/guillotine/*
*/

















